#include <cstdlib>
#include <iostream>
#include <cmath>
#include "AlberoN.h"
#include "Cella.h"
#include "codavt.h"


using namespace std;

Coda<int> riempi()
{
   // inserimento in ampiezza
   Coda<int> c;
   c.inCoda(1); c.inCoda(2);
   c.inCoda(3); c.inCoda(4); c.inCoda(5);
   c.inCoda(6); c.inCoda(7); c.inCoda(8);
   c.inCoda(9);c.inCoda(10); c.inCoda(11);
   c.inCoda(12);    c.inCoda(13);
   c.inCoda(14);c.inCoda(15);
   c.inCoda(16);c.inCoda(17);c.inCoda(18);
   c.inCoda(19);c.inCoda(20);c.inCoda(21);
   c.inCoda(22);c.inCoda(23);c.inCoda(24);
   c.inCoda(25);c.inCoda(26);c.inCoda(27);
   c.inCoda(28);c.inCoda(29);c.inCoda(30);
   c.inCoda(31);c.inCoda(32);c.inCoda(33);
   c.inCoda(34);c.inCoda(35);c.inCoda(36);
   c.inCoda(37);c.inCoda(38);c.inCoda(39);
   c.inCoda(40); 
   return(c);
}

void riempi(Coda<int> dati,Albero<int>& t)
{
      if (!t.alberoVuoto())
      {
         Coda<Albero<int>::Nodo> s;
         s.inCoda(t.radice());
         while (!s.codaVuota()){
               Albero<int>::Nodo nn=s.leggiCoda(); // visito un nodo ...
               t.scriviNodo(nn,dati.leggiCoda());
               s.fuoriCoda();
               dati.fuoriCoda();
               if (!t.foglia(nn))
               {
                  s.inCoda(t.primoFiglio(nn)); // ... e accodo i figli di nn
                  bool ancora_fratelli=!t.ultimoFratello(t.primoFiglio(nn));
                  Albero<int>::Nodo next=t.primoFiglio(nn);
                  while (ancora_fratelli)
                  {
                     next=t.succFratello(next);
                     s.inCoda(next);
                     ancora_fratelli=!t.ultimoFratello(next);
                  }
               }               
         }
      }
}

Albero<int> espandiFoglie(Albero<int> &t, int n)
{
    // visita t ed espande le foglie con n figli
    
    if (!t.alberoVuoto())
    {
         Coda<Albero<int>::Nodo> s;
         s.inCoda(t.radice());
         while (!s.codaVuota()){
               Albero<int>::Nodo nn=s.leggiCoda(); // visito un nodo ...
               s.fuoriCoda();
               if (t.foglia(nn))
               {
                  // processo un nodo solo se  foglia        
                  for (int j=1;j<=n;j++)
                  {
                     Albero<int> figlio;
                     figlio.insRadice(new Cella<int>);
                     t.scriviNodo(figlio.radice(),0);
                     t.insPrimoSottoalbero(nn,figlio);
                  }
                  // cout << "completata aggiunta figli" << endl;  
               }
               else
               {                  
                  s.inCoda(t.primoFiglio(nn)); // ... e accodo i figli di nn
                  bool ancora_fratelli=!t.ultimoFratello(t.primoFiglio(nn));
                  Albero<int>::Nodo next=t.primoFiglio(nn);
                  while (ancora_fratelli)
                  {
                     next=t.succFratello(next);
                     s.inCoda(next);
                     ancora_fratelli=!t.ultimoFratello(next);
                  }
               }               
         }
      }
}

Albero<int> costruisci(int nlivelli, int nfigli)
{
    // costruiamo un albero di nlivelli
    assert(nlivelli>=1 && nfigli>=0); // almeno livello radice
    Albero<int> tree;
    tree.insRadice(new Cella<int>);
    tree.scriviNodo(tree.radice(),0);
    // costruito livello 0 ovvero primo livello
    if (nlivelli>=2)
    {
       // se ho almeno due livello inizio ad espandere
       for (int level=0;level<=nlivelli-2;level++)
       // espando le foglie per ogni livello
       espandiFoglie(tree,nfigli);
    }
    return tree;
}    

int calcolaLivello(Albero<int> &tree, Albero<int>::Nodo node)
{
   // calcola il livello del nodo node
   int livello;
   if (tree.radice()==node)
      livello=0;
   else
      livello=calcolaLivello(tree, tree.padre(node))+1;   
   return livello;
}


int somma(Albero<int> &tree, Albero<int>::Nodo radice)
{
   int s=tree.leggiNodo(radice);
   if (!tree.foglia(radice))
   {
       //  s  la somma dei tutti i sottoalberi
       Albero<int>::Nodo next = tree.primoFiglio(radice);
       s+=somma(tree,next);
       while (!tree.ultimoFratello(next))
       {
          next=tree.succFratello(next);
           s+=somma(tree,next);
       }
       
   }
   return s;
}
    
int somma(Albero<int> &tree)
{
   // calcola la somma dei nodi in tree
   // usando la funzione ricorsiva somma(albero,nodo)
   int s=0;
   if (!tree.alberoVuoto())
   {
      s=somma(tree,tree.radice());
   } 
   return s;
}
    
void pesa(Albero<int>& t)
{
      if (!t.alberoVuoto())
      {
         Coda<Albero<int>::Nodo> s;
         s.inCoda(t.radice());
         while (!s.codaVuota()){
               Albero<int>::Nodo nn=s.leggiCoda(); // visito un nodo ...
               t.scriviNodo(nn,somma(t,nn));
               s.fuoriCoda();
               if (!t.foglia(nn))
               {
                  s.inCoda(t.primoFiglio(nn)); // ... e accodo i figli di nn
                  bool ancora_fratelli=!t.ultimoFratello(t.primoFiglio(nn));
                  Albero<int>::Nodo next=t.primoFiglio(nn);
                  while (ancora_fratelli)
                  {
                     next=t.succFratello(next);
                     s.inCoda(next);
                     ancora_fratelli=!t.ultimoFratello(next);
                  }
               }               
         }
      }
}


int sommaLivello(Albero<int>& t, int k)
{
      int somma=0;
      if (!t.alberoVuoto())
      {
         Coda<Albero<int>::Nodo> s;
         s.inCoda(t.radice());
         while (!s.codaVuota()){
               Albero<int>::Nodo nn=s.leggiCoda(); // visito un nodo ...
               if (k==calcolaLivello(t,nn)) // processa
                  somma+=t.leggiNodo(nn);
               s.fuoriCoda();
               if (!t.foglia(nn))
               {
                  s.inCoda(t.primoFiglio(nn)); // ... e accodo i figli di nn
                  bool ancora_fratelli=!t.ultimoFratello(t.primoFiglio(nn));
                  Albero<int>::Nodo next=t.primoFiglio(nn);
                  while (ancora_fratelli)
                  {
                     next=t.succFratello(next);
                     s.inCoda(next);
                     ancora_fratelli=!t.ultimoFratello(next);
                  }
               }               
         }
      }
      return somma;
}


                  
int main(int argc, char *argv[])
{
    cout << "creazione albero" << endl;
    // costruisco un albero di interi con 3 livelli
    // ogni nodo ha 3 figli
    int livelli=4;
    int figli=3;
    Albero<int> tree=costruisci(livelli,figli); 
    riempi(riempi(),tree);
    tree.stampa(tree.radice(),0);
    cout << "somma dei nodi=" << somma(tree) << endl;
    pesa(tree);
    tree.stampa(tree.radice(),0);
    cout << "somma livello 0:" << sommaLivello(tree,0) << endl;
    cout << "somma livello 1:" << sommaLivello(tree,1) << endl;
    cout << "somma livello 2:" << sommaLivello(tree,2) << endl;
    cout << "somma livello 3:" << sommaLivello(tree,3) << endl;
    cout << "somma livello 4:" << sommaLivello(tree,4) << endl;
    
    system("PAUSE");
    return EXIT_SUCCESS;
}
